/* btslave.c */ 
#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "config.h"

/* OSEK declarations */
DeclareCounter(SysTimerCnt);
DeclareTask(EventDispatcher); 
DeclareTask(EventHandler);
//DeclareTask(LineFollowerTask);
DeclareTask(IdleTask);
/*DeclareEvent(TouchSensorOnEvent);
DeclareEvent(TouchSensorOffEvent); */
DeclareEvent(StartFollow);
DeclareEvent(StopFollow); 

/* below macro enables run-time Bluetooth connection */
#define RUNTIME_CONNECTION


/*Declare Global variables*/
U8 counter;
int first=1;stop_flag=1,white_flag,start,count,turn_flag,turn_flag_1,turn,end_turn,end_turn_count;
volatile int lightValue; // data from light sensor

/* LEJOS OSEK hooks */
void ecrobot_device_initialize()
{

	ecrobot_init_nxtcolorsensor(COLOR_RIGHT, NXT_LIGHTSENSOR_RED); // initialize main color sensor
	ecrobot_set_nxtcolorsensor(COLOR_RIGHT,NXT_LIGHTSENSOR_RED); //use RED color
	ecrobot_init_nxtcolorsensor(COLOR_LEFT, NXT_LIGHTSENSOR_RED); // initialize main color sensor
	ecrobot_set_nxtcolorsensor(COLOR_LEFT,NXT_LIGHTSENSOR_RED); //use RED color
	ecrobot_init_nxtcolorsensor(COUNT_COLOR, NXT_LIGHTSENSOR_RED); // initialize secondary color sensor
	ecrobot_set_nxtcolorsensor(COUNT_COLOR,NXT_LIGHTSENSOR_RED); //use RED color

#ifndef RUNTIME_CONNECTION
  ecrobot_init_bt_slave("LEJOS-OSEK");
#endif
	
}

void ecrobot_device_terminate()
{
	ecrobot_term_bt_connection();
	ecrobot_term_nxtcolorsensor(COLOR_RIGHT); // terminate main sensor
	ecrobot_term_nxtcolorsensor(COLOR_LEFT); // terminate main sensor
	ecrobot_term_nxtcolorsensor(COUNT_COLOR); // terminate secondary sensor
}

/* LEJOS OSEK hook to be invoked from an ISR in category 2 */
void user_1ms_isr_type2(void)
{
  StatusType ercd;

  ercd = SignalCounter(SysTimerCnt); /* Increment OSEK Alarm Counter */
  if(ercd != E_OK)
  {
    ShutdownOS(ercd);
  }
}


/*Line follower function*/
void line_follow()
{
	//basic line follow logic for test
     /*  if (ecrobot_get_nxtcolorsensor_light(COLOR_RIGHT) > COLOR_THRESHOLD){
    	// if white right motor goes forward  
	ecrobot_set_motor_speed(RIGHT_MOTOR,-30);
  	}
  	else if (ecrobot_get_nxtcolorsensor_light(COLOR_RIGHT) < COLOR_THRESHOLD)
  	{
		//if black right motor goes backward 
	ecrobot_set_motor_speed(RIGHT_MOTOR,50);
  	}
	
	if (ecrobot_get_nxtcolorsensor_light(COLOR_LEFT) > COLOR_THRESHOLD){
    	// if white left motor goes forward
	ecrobot_set_motor_speed(LEFT_MOTOR,-30);
	
  	}
  	else if (ecrobot_get_nxtcolorsensor_light(COLOR_LEFT) < COLOR_THRESHOLD)
  	{
		//if black left motor goes backward  
    	ecrobot_set_motor_speed(LEFT_MOTOR,50);
	
  	}*/

/*Initial branch logic by using turn values,once branch is resolved normal line following continues*/
  if(turn==1 && turn_flag)//turn=1 left
		{//turn left if on branch and both sensors on black
					
			ecrobot_set_motor_speed(RIGHT_MOTOR,-40);//forward
			ecrobot_set_motor_speed(LEFT_MOTOR,40);//backward
			turn_flag++;
			if(turn_flag>70)
			   {
				turn=0;				
				turn_flag=0;
			   }
	
		}
		else if(turn==2 && turn_flag_1)//turn=2 right
		{
		//turn right until both on white again	
		
			ecrobot_set_motor_speed(RIGHT_MOTOR,50);//backward
			ecrobot_set_motor_speed(LEFT_MOTOR,-50);// forward
			turn_flag_1++;
			if(turn_flag_1>70)
			   {
				turn=0;				
				turn_flag_1=0;
			   }
		}
 else{//default for line following

  if ((ecrobot_get_nxtcolorsensor_light(COLOR_RIGHT) > COLOR_THRESHOLD)&&(ecrobot_get_nxtcolorsensor_light(COLOR_LEFT) > COLOR_THRESHOLD))
   {
    		
			// if white right motor goes forward LR WW-FF
		ecrobot_set_motor_speed(LEFT_MOTOR,-30);		
		ecrobot_set_motor_speed(RIGHT_MOTOR,-30);
		if(turn==0 && end_turn_count>1000)
		   end_turn=1;	
		else if(turn==0 && end_turn_count<=1000)
		   end_turn_count++;
  	}
  else if ((ecrobot_get_nxtcolorsensor_light(COLOR_RIGHT) < COLOR_THRESHOLD)&&(ecrobot_get_nxtcolorsensor_light(COLOR_LEFT) > COLOR_THRESHOLD))
  {
		//if black right motor goes backward WB-FB
		ecrobot_set_motor_speed(LEFT_MOTOR,-30);		
		ecrobot_set_motor_speed(RIGHT_MOTOR,30);
  	}
	
 else if ((ecrobot_get_nxtcolorsensor_light(COLOR_RIGHT) > COLOR_THRESHOLD)&&(ecrobot_get_nxtcolorsensor_light(COLOR_LEFT) < COLOR_THRESHOLD))
   {
    		// if white left motor goes forward BW -BF
		ecrobot_set_motor_speed(LEFT_MOTOR,30);		
		ecrobot_set_motor_speed(RIGHT_MOTOR,-30);
	
  	}
 else if ((ecrobot_get_nxtcolorsensor_light(COLOR_RIGHT) < COLOR_THRESHOLD)&&(ecrobot_get_nxtcolorsensor_light(COLOR_LEFT) < COLOR_THRESHOLD))
  {
		//if black left motor goes backward BB 
	//handle the branch turn case as per turn sensor 1-left 2-right 0--default is right when branch is detected
		if(turn==1)turn_flag=1;
		else if(turn==2)turn_flag_1=1;  		
   }
 }
}


/* EventDispatcher executed every 5ms */
TASK(EventDispatcher)
{
  static U8 bt_receive_buf[32]; 
  static U8 TouchSensorStatus_old = 0;
  U8 TouchSensorStatus; 
  ecrobot_process_bg_nxtcolorsensor(); // communicates with NXT Color Sensor (this must be executed repeatedly in a background Task)
  int val1= ecrobot_get_nxtcolorsensor_light(COUNT_COLOR);
  int val2= ecrobot_get_nxtcolorsensor_light(COLOR_LEFT);
  int val3= ecrobot_get_nxtcolorsensor_light(COLOR_RIGHT);
  /* read packet data from the master device */  
  ecrobot_read_bt_packet(bt_receive_buf, 32);

//implements one shot bt data transfer i.e once data is intialize not further data is accepted from master
  if(first)
   {
  counter=bt_receive_buf[0];
 turn=bt_receive_buf[1];
   }

//lcd display for debugging
  display_goto_xy(4,4);
      display_int(bt_receive_buf[0],0);
   display_goto_xy(6,4);
      display_int(bt_receive_buf[1],0);
 display_goto_xy(5,5);
      display_int(counter,0); // display the current sensor value
 display_goto_xy(9,5);
      display_int(turn,0); // display the current sensor value
  display_goto_xy(6,6);
      display_int(count,0); // display the counter value
 display_goto_xy(3,3);
      display_int(val1,0); // display the current sensor value
  display_goto_xy(9,3);
      display_int(val2,0); // display the current sensor value
   display_goto_xy(9,2);
      display_int(val3,0); // display the current sensor value
 display_update();
  
  
 if(!counter)//init condition when BT connection is being established
  {
	SetEvent(EventHandler, StopFollow);
  }
  else if (counter==1)//counter value to implement stop and go feature with a wait time
  {
	SetEvent(EventHandler, StopFollow);
	count++;
	if(start && (count>=1000))  	//implements a wait time
	counter=200;
  }
 else if(counter == 200)//condition after stop point has been reached 
  {
	line_follow(); //continue following line but do not stop at any points
  }
  else
  {
  	first=0; // init condition passed
	SetEvent(EventHandler, StartFollow);
	line_follow(); // follow line 
	if(end_turn) // condition to neglect any marks before branch is taken
	{
	/*Stop points counter logic for bluetooth counter values*/
     	if(ecrobot_get_nxtcolorsensor_light(COUNT_COLOR)< COLOR_CHECK && white_flag)
		{

		counter--;
		stop_flag=1;
		white_flag=0;
		}
	
       
       if(ecrobot_get_nxtcolorsensor_light(COUNT_COLOR)> COLOR_CHECK && stop_flag)
		{
		white_flag=1;
		stop_flag=0;
		}
	}
  }  	

  TerminateTask();
}

/* EventHandler executed by OSEK Events */
TASK(EventHandler)
{
  static U8 bt_send_buf[32]; 

  while(1)
  {

    WaitEvent(StopFollow); /* Task is in waiting status until the Event comes */
    ClearEvent(StopFollow); 
        ecrobot_set_motor_speed(LEFT_MOTOR,0);
    	ecrobot_set_motor_speed(RIGHT_MOTOR,0);
	

    WaitEvent(StartFollow); /* Task is in waiting status until the Event comes*/ 
    ClearEvent(StartFollow);
		start=1;
    
  
  
  }

  TerminateTask();
}




/* IdleTask */
TASK(IdleTask)
{
  static SINT bt_status = BT_NO_INIT;	
  int val;
  
  
  while(1)
  {  
#ifdef RUNTIME_CONNECTION
    ecrobot_init_bt_slave("LEJOS-OSEK");
#endif
    if (ecrobot_get_bt_status() == BT_STREAM && bt_status != BT_STREAM)
    {
      display_clear(0);
      display_goto_xy(0, 0);
      display_string("[BT]");
      display_goto_xy(10,1);
      display_int(lightValue,0); // display the current sensor value
      display_update();
    }
    bt_status = ecrobot_get_bt_status();
  }	
}
